//+------------------------------------------------------------------+
//|                                                       MA8-13.mq4 |
//|                      Copyright  2008, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

//---- input parameters
extern int ExtPeriod1=8;
extern int ExtPeriod2=13;
int start()
   {
   static datetime PrevTime=0;
   double Ma8Current,Ma8Previous,Ma8Previous2;
   double Ma13Current,Ma13Previous,Ma13Previous2;
   bool IsCrossDown,IsCrossUp;
   if(PrevTime==Time[0]) return(0);
   PrevTime=Time[0];
   Ma8Current=iMA(NULL,0,ExtPeriod1,0,MODE_EMA,PRICE_OPEN,0);
   Ma8Previous=iMA(NULL,0,ExtPeriod1,0,MODE_EMA,PRICE_OPEN,1);
   Ma8Previous2=iMA(NULL,0,ExtPeriod1,0,MODE_EMA,PRICE_OPEN,2);
   Ma13Current=iMA(NULL,0,ExtPeriod2,0,MODE_EMA,PRICE_OPEN,0);
   Ma13Previous=iMA(NULL,0,ExtPeriod2,0,MODE_EMA,PRICE_OPEN,1);
   Ma13Previous2=iMA(NULL,0,ExtPeriod2,0,MODE_EMA,PRICE_OPEN,1);
   
   IsCrossDown=(Ma8Current<Ma13Current && Ma8Previous>=Ma13Previous && Ma8Previous2>Ma13Previous2);
   IsCrossUp=(Ma8Current>Ma13Current && Ma8Previous<=Ma13Previous && Ma8Previous2<Ma13Previous2);
   
   if(IsCrossDown)
    {
     for(int i=OrdersTotal()-1;i>=0;i--)         
     {
      OrderSelect(i,SELECT_BY_POS, MODE_TRADES);
      if(OrderSymbol()==Symbol() && OrderType()==OP_BUY)
      OrderClose(OrderTicket(),OrderLots(),Bid,0);
       }
       OrderSend(Symbol(),OP_SELL,0.11,Bid,0,0.0,0.0);
   }
   if(IsCrossUp)
    {
    for(i=OrdersTotal()-1;i>=0; i--)
     {
      OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if(OrderSymbol()==Symbol()&& OrderType()==OP_SELL)
      OrderClose(OrderTicket(),OrderLots(),Ask,0);
      }
     OrderSend(Symbol(),OP_BUY,0.11,Ask,0,0.0,0.0);
     }
     return(0);
   }